package squidcache;

require 'util.pl';
use File::Basename;
use strict;

BEGIN {
}

sub mediatype()    {'application/x-squid-cache'; }
sub recursive()    {1; }
sub pre_codeconv() {0; }
sub post_codeconv(){0; }

sub status() {
    return 'yes';
}

# MagicEntryν狼SquidCacheƬΥХʥ꤬ʤΤ⤷...
sub add_magic ($) {
    my ($magic) = @_;
    $magic->addMagicEntry("2\tstring\t".'\x00\x00\x00\x03\x10\x00\x00\x00'."\tapplication/x-squid-cache");
}

sub _replacecode {
  my $filename = shift;
  
  my ($name, $path) = fileparse($filename);
  if (open(FILE, $filename)) {
      # get url allowed to squid cache file format
      # 60 byte skip, url end with '\x00"
      my $c = '';
      read(FILE, $c, 512 + 60);
      close(FILE);
      $filename = getsquidurl($c);
  } else {
      util::vprint("Can not open URL file: $filename\n");   
  }
  return $filename;
}

sub replacecode {
    $_ = _replacecode($_);
}

sub getsquidurl {
    my ($str) = @_;
    # 60byte ɤФ
    $str = substr($str, 60, 512); 
    # hǻϤޤ(http://... )\x00ǽʬURL
    $str =~ /^(h[^\x00]+)\x00/;
    $str = $1;
    $str;
}

# ǥåƤѹ뤿ΤΤ?
sub filter ($$$$$) {
    my ($orig_cfile, $contref, $weighted_str, $headings, $fields) = @_;
    util::vprint($$orig_cfile . "\n");
    #----- [url or data?] -----

    my $url = getsquidurl($$contref);
    if (defined $url && $url =~ /^h/ && $$contref =~ s/^(.*?)(?:\015\012\015\012|\r?\n\r?\n)//s) {
        # Content-Type ȴФ
        my ($header) = $1;
        my ($content_type);
        if ($header =~ /Content-Type:\s*([\w\/]+)/i) {
	    $content_type = $1;
        }
    }
    desquidcache($contref);
    return undef;  
}

sub desquidcache ($) {
    my $contref = shift @_;
    $$contref =~ s/^([^\r\n]+\r\n)+\r\n//s;
}

1;
